SystemOrganization addCategory: #'SandstoneDb-Core'!
SystemOrganization addCategory: #'SandstoneDb-Store'!
SystemOrganization addCategory: #'SandstoneDb-Tests'!

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:36'!
sandstoneDeepCopy
	^ self shallowCopy! !

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:36'!
sandstoneDeepCopyVisits: visitedParts
	^ self shallowCopy! !

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 8/3/2008 00:37'!
sandstoneMarkReferencesVisits: visitedParts
	^ self! !

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 8/3/2008 00:21'!
sandstoneResolveReferencesVisits: visitedParts 
	^ self! !

!FileDirectory methodsFor: '*sandstonedb' stamp: 'rjl 8/9/2008 22:48'!
sandstoneRename: oldFileName toBe: newFileName
	| oldName newName |
	"a non interactive version of rename that won't promp the UI on failure"
	oldName := self fullNameFor: oldFileName.
	newName := self fullNameFor: newFileName.
	(StandardFileStream 
		retryWithGC:[self primRename: oldName asVmPathName to: newName asVmPathName]
		until:[:result| result notNil]
		forFileNamed: oldName) ~~ nil ifTrue:[^self].
	(self fileExists: oldFileName) ifFalse:[
		^self error:'Attempt to rename a non-existent file'.
	].
	^self error:'Failed to rename file'.! !

!FileDirectory methodsFor: '*sandstonedb' stamp: 'rjl 8/5/2008 22:48'!
withSubdirectoriesDo: aBlock 
	self directoryNames do: [ :n | aBlock value: (self directoryNamed: n) ]! !

!Character methodsFor: '*sandstonedb' stamp: 'rjl 5/12/2008 22:34'!
sandstoneDeepCopy
	^ self! !

!Character methodsFor: '*sandstonedb' stamp: 'rjl 5/12/2008 22:34'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Character methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:55'!
sandstoneMarkReferencesVisits: visitedParts
	^ self! !

!Character methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:55'!
sandstoneResolveReferencesVisits: visitedParts 
	^ self! !

!ArrayedCollection methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:08'!
deservesSandstoneReferenceMark
	^ false! !

!Complex methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:58'!
sandstoneDeepCopy
	^ self! !

!Complex methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:58'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Complex methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:42'!
sandstoneMarkReferencesVisits: visitedParts
	^ self! !

!Complex methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:41'!
sandstoneResolveReferencesVisits: visitedParts 
	^ self! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:56'!
fileNamed: aName do: aBlock 
	| file |
	file := self fileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:57'!
newFileNamed: aName do: aBlock 
	| file |
	file := self newFileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:57'!
oldFileNamed: aName do: aBlock 
	| file |
	file := self oldFileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/12/2008 16:51'!
readOnlyFileNamed: aString
	| strm |
	strm := self on: (FileStream readOnlyFileNamed: aString).
	strm byteStream setFileTypeToObject.
	^ strm! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:56'!
readOnlyFileNamed: aName do: aBlock 
	| file |
	file := self readOnlyFileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

TestCase subclass: #SDActiveRecordTests
	instanceVariableNames: 'mom kid store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

!SDActiveRecordTests commentStamp: 'rjl 12/19/2007 20:41' prior: 0!
Part of the reason I did this project was to force myself to learn to do more unit testing.  I'm starting to learn to like it.!

!SDActiveRecordTests class methodsFor: 'testing' stamp: 'rjl 8/10/2008 11:05'!
isAbstract
	^ true! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/10/2008 11:05'!
defaultStore
	self subclassResponsibility! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 00:17'!
flushAndReload
	SDPersonMock
		coolDown ;
		warmUp! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/12/2008 20:05'!
setUp
	store := self defaultStore.
	SDPersonMock setStore: store.
	SDPersonMock warmUp.
	SDPersonMock allSubclassesDo: [ :each | each warmUp ].
	mom := SDPersonMock testPerson.
	kid := SDPersonMock testPerson.
! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'test 8/27/2008 09:19'!
tearDown
	SDPersonMock do: [ :each | each delete ].
	SDPersonMock coolDown.
	SDPersonMock allSubclassesDo: [ :each | each coolDown ]! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/21/2008 16:04'!
testAbort
	kid name: 'Joe'.
	kid save.
	kid name: 'Mary'.
	self assert: kid name = 'Mary'.
	kid abortChanges.
	self assert: kid name = 'Joe'! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'test 8/14/2008 20:30'!
testArraySerialization
	kid save.
	mom children: {  kid  }.
	mom save.
	self flushAndReload.
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/14/2008 21:37'!
testAtIdSubclasses
	| man woman |
	man := SDManMock testPerson save.
	woman := SDWomanMock testPerson save.
	mom save.
	self assert: (SDPersonMock atId: mom id) = mom.
	self assert: (SDPersonMock atId: man id) = man.
	self assert: (SDPersonMock atId: woman id) = woman.
	man delete.
	woman delete! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/13/2008 10:17'!
testBagSerialization
	kid save.
	mom children: (Bag with: kid).
	mom save.
	self flushAndReload .
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/14/2008 14:25'!
testBigSave
	| commitTime people deleteTime |
	people := (1 to: 40) collect: [ :it | SDPersonMock testPerson ].
	commitTime := [ people do: [ :each | each save ] ] timeToRun milliSeconds.
	deleteTime := [ people do: [ :each | each delete ] ] timeToRun milliSeconds.
	Transcript
		show: commitTime;
		cr;
		show: deleteTime;
		cr.
	self assert: commitTime < 4 seconds.
	self assert: deleteTime < 3 seconds! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:56'!
testCollectionSerialization
	kid save.
	mom children: (OrderedCollection with: kid).
	mom save.
	self flushAndReload .
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/19/2007 21:04'!
testCreatedOn
	kid save.
	self assert: kid createdOn <= TimeStamp now! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 23:24'!
testDeepCopy
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| copy obj |
	kid save.
	mom save.
	kid buddy: #not -> (#deeper -> mom).
	obj := Object new.
	kid father: obj.
	copy := kid sandstoneDeepCopy.
	self assert: copy buddy value value == mom.
	self deny: copy father == obj! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/12/2008 21:59'!
testDelete
	kid save.
	self deny: kid isNew.
	self assert: kid version equals: 1.
	kid delete.
	self assert: kid isNew.
	self assert: kid version equals: 0.
	self flushAndReload.
	self assert: (SDPersonMock find: [ :each | each id = kid id ]) isNil.
! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 2/4/2008 10:46'!
testDeleteAndFind
	kid name: 'zorgle'.
	kid save.
	self deny: kid isNew.
	kid delete.
	self assert: (SDPersonMock find: [:e | e name = 'zorgle']) isNil.
! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/12/2008 22:00'!
testDeleteSubclass
	kid := SDManMock testPerson save.
	self deny: kid isNew.
	self assert: kid version equals: 1.
	kid delete.
	self assert: kid isNew.
	self assert: kid version equals: 0.
	self flushAndReload.
	self assert: (SDManMock find: [ :each | each id = kid id ]) isNil.
! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/12/2008 20:09'!
testDictionarySerialization
	kid save.
	mom children: (Dictionary with: #son -> kid).
	mom save.
	self flushAndReload.
	self 
		assert: (mom refreshed children at: #son)
		equals: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:54'!
testEquality
	mom save.
	kid mother: mom.
	kid save.
	self flushAndReload .
	self assert: kid refreshed mother equals: mom refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/12/2008 23:06'!
testFind
	kid save.
	self flushAndReload.
	self deny: (SDPersonMock find: [ :each | each id = kid id ]) isNil.
	self assert: (SDPersonMock find: [ :each | each id = 'not' ]) isNil! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/22/2008 10:45'!
testFindById
	kid save.
	self deny: (SDPersonMock atId: kid id) isNil! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/14/2008 16:24'!
testFindIdentity
	mom save.
	self flushAndReload.
	self assert: (SDPersonMock atId: mom id) = (SDPersonMock atId: mom id)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 9/18/2008 11:19'!
testFindSubclasses
	| man woman child grandchild |
	man := SDManMock testPerson save.
	woman := SDWomanMock testPerson save.
	child := SDChildMock testPerson save.
	grandchild := SDGrandChildMock testPerson save.
	mom save.
	self 
		assert: 5
		equals: SDPersonMock findAll size.
	self assert: (SDPersonMock findAll contains: [ :e | e class = SDManMock ]).
	self 
		assert: 1
		equals: SDManMock findAll size.
	self 
		assert: 3
		equals: SDWomanMock findAll size.
	self 
		assert: 2
		equals: SDChildMock findAll size.
	self 
		assert: 1
		equals: SDGrandChildMock findAll size.
	man delete.
	woman delete.
	child delete.
	grandchild delete! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/14/2008 23:23'!
testIdentity
	mom save.
	kid mother: mom.
	kid save.
	self flushAndReload.
	self assert: kid refreshed mother == mom refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:55'!
testIsNew
	self assert: kid isNew.
	kid save.
	self deny: kid isNew.
	kid delete.
	self assert: kid isNew.! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:47'!
testMarkReferences
	kid mother: mom.
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid mother isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:49'!
testMarkReferencesCopies
	kid save.
	mom children: { kid }.
	mom save.
	self assert: mom children first == kid! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:47'!
testMarkReferencesRecursive
	kid buddy: #not -> mom.
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:48'!
testMarkReferencesRecursiveDeeper
	kid buddy: #not -> (#deeper -> mom).
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value value isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:48'!
testMarkReferencesRecursiveDeeperInCollection
	kid buddy: #not -> {  (#deeper -> mom)  }.
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value first value isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/12/2008 20:10'!
testMarkReferencesRecursiveDeeperInDictionary
	kid buddy: #not -> { (Dictionary with: #deeper -> mom) }.
	mom save.
	kid sandstoneMarkReferences.
	self assert: ((kid buddy value first at: #deeper) isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:48'!
testMarkReferencesRecursiveDeeperNestedList
	kid buddy: #not -> (Array with: (Array with: mom)).
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value first first isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 7/10/2008 09:42'!
testMarkReferencesRecursiveDeeperNotTouchedInOrig
	| otherKid |
	kid buddy: #not -> (#deeper -> mom).
	otherKid := kid sandstoneDeepCopy.
	otherKid buddy value value save.
	otherKid sandstoneMarkReferences.
	self assert: (kid buddy value value isKindOf: mom class)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/13/2008 23:58'!
testMarkReferencesStops
	| other |
	other := SDManMock testPerson save.
	mom father: other.
	kid buddy: #some -> (#time -> mom).
	mom save.
	kid sandstoneMarkReferences.
	self assert: (mom father == other)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 8/14/2008 14:24'!
testPeerIdentity
	mom save.
	kid mother: mom.
	kid save.
	self flushAndReload.
	self assert: kid refreshed mother = mom refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 21:07'!
testResolveReferences
	mom save.
	kid mother: mom asReferenceMarker.
	kid sandstoneResolveReferences.
	self assert: (kid mother isKindOf: SDActiveRecord)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 21:07'!
testResolveReferencesRecursive
	mom save.
	kid buddy: #not -> mom asReferenceMarker.
	kid sandstoneResolveReferences.
	self assert: (kid buddy value isKindOf: SDActiveRecord)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 21:07'!
testResolveReferencesRecursiveDeeperNestedList
	mom save.
	kid buddy: #not -> (Array with: (Array with: mom asReferenceMarker)).
	kid sandstoneResolveReferences.
	self assert: (kid buddy value first first isKindOf: SDActiveRecord)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:57'!
testSetSerialization
	kid save.
	mom children: (Set with: kid).
	mom save.
	self flushAndReload.
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/19/2007 21:07'!
testUpdatedOn
	kid save.
	self assert: kid updatedOn <= TimeStamp now! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 7/14/2008 23:26'!
testVersion
	self assert: kid version equals: 0.
	kid save.
	self assert: kid version equals: 1.
	kid save.
	self assert: kid version equals: 2! !

SDActiveRecordTests subclass: #SDFileStoreTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

!SDFileStoreTests class methodsFor: 'testing' stamp: 'rjl 8/10/2008 11:06'!
isAbstract
	^ false! !

!SDFileStoreTests methodsFor: 'defaults' stamp: 'rjl 8/10/2008 11:05'!
defaultStore
	^ SDFileStore new! !

!SDFileStoreTests methodsFor: 'running' stamp: 'rjl 8/10/2008 11:27'!
testDeleteFailedCommits
	kid save.
	(store 
		dirForClass: kid class
		atId: kid id) 
		copyFileNamed: kid id , '.obj'
		toFileNamed: kid id , '.obj.new'.
	self assert: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj').
	self assert: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj.new').
	store deleteFailedCommitsForClass: kid class.
	self assert: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj').
	self deny: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj.new')! !

!SDFileStoreTests methodsFor: 'running' stamp: 'rjl 8/10/2008 11:27'!
testDeleteOldVersions
	| id |
	kid save.
	kid save.
	id := kid id.
	kid delete.
	self assert: ((store 
			dirForClass: kid class
			atId: id) fileNamesMatching: id , '.*') isEmpty! !

!SDFileStoreTests methodsFor: 'running' stamp: 'rjl 8/10/2008 11:27'!
testFinishPartialCommits
	kid save.
	(store 
		dirForClass: kid class
		atId: kid id) 
		rename: kid id , '.obj'
		toBe: kid id , '.obj.new'.
	self deny: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj').
	self assert: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj.new').
	store finishPartialCommitsForClass: kid class.
	self assert: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj').
	self deny: ((store 
			dirForClass: kid class
			atId: kid id) fileExists: kid id , '.obj.new')! !

!SDFileStoreTests methodsFor: 'running' stamp: 'rjl 8/14/2008 20:50'!
testLoadMissingFile
	kid save.
	(store 
		dirForClass: kid class
		atId: kid id) deleteFileNamed: kid id , '.obj'.
	self 
		should: 
			[ store 
				loadClass: kid class
				atId: kid id ]
		raise: SDLoadError! !

!SDFileStoreTests methodsFor: 'running' stamp: 'rjl 8/10/2008 11:27'!
testSaveMissingFile
	self assert: kid isNew.
	kid save.
	self deny: kid isNew.
	(store 
		dirForClass: kid class
		atId: kid id) deleteFileNamed: kid id , '.obj'.
	kid save.
	self deny: kid isNew! !

!SDFileStoreTests methodsFor: 'running' stamp: 'rjl 8/10/2008 11:30'!
testStorageDir
	"Active records id's must find a proper subdirectory entry in the defined structure"
	| ids legalNames |
	legalNames := (0 to: 9) collect: [ :e | e asString ].
	ids := Set new: 1000.
	1000 timesRepeat: [ ids add: UUID new asString36 ].
	ids add: 'abaoblwgnaydxokccorveamoq'.
	ids do: 
		[ :anId | 
		self assert: (legalNames includes: (store 
					dirForClass: SDPersonMock
					atId: anId) localName) ]! !

SDActiveRecordTests subclass: #SDMemoryStoreTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

!SDMemoryStoreTests class methodsFor: 'testing' stamp: 'rjl 8/10/2008 11:06'!
isAbstract
	^ false! !

!SDMemoryStoreTests methodsFor: 'defaults' stamp: 'rjl 8/10/2008 11:07'!
defaultStore
	^ SDMemoryStore new! !

!Object methodsFor: '*sandstonedb-testing' stamp: 'rjl 7/31/2008 17:08'!
deservesSandstoneReferenceMark
	^ true ! !

!Object methodsFor: '*sandstonedb-testing' stamp: 'sas 4/9/2008 13:20'!
isSandstoneActiveRecord
	"Answers true if the receiver is
	a Sandstone Active Record."

	^ false! !

!Object methodsFor: '*sandstonedb-testing' stamp: 'rjl 7/8/2008 15:40'!
isSandstoneMarker
	^ false! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:07'!
sandstoneDeepCopy
	"Replaces the receiver (sub) active records 
	with Sandstone references where it is needed"
	^ self sandstoneDeepCopyVisits: (IdentityDictionary new: self sandstoneInitialHashSize)! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/18/2008 01:51'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject class index value |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	class := self class.
	class isVariable 
		ifTrue: 
			[ index := self basicSize.
			newObject := class basicNew: index.
			[ index > 0 ] whileTrue: 
				[ newObject 
					basicAt: index
					put: ((self basicAt: index) sandstoneDeepCopyVisits: visitedParts).
				index := index - 1 ] ]
		ifFalse: [ newObject := class basicNew ].
	visitedParts at: self put: newObject.
	index := class instSize.
	[ index > 0 ] whileTrue: 
		[ value := self instVarAt: index.
		newObject 
			instVarAt: index
			put: (value isSandstoneActiveRecord 
					ifTrue: [ value  ]
					ifFalse: [ value sandstoneDeepCopyVisits: visitedParts ]).
		index := index - 1 ].
	^ newObject! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:06'!
sandstoneInitialHashSize
	^ 10000! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:06'!
sandstoneMarkReferences
	"Replaces the receiver (sub) active records 
	with Sandstone references where it is needed"
	^ self sandstoneMarkReferencesVisits: (IdentityDictionary new: self sandstoneInitialHashSize)! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 15:40'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ it ].
	visitedParts at: self put: self.
	self class allInstVarNames do: 
		[ :name | 
		| var |
		var := self instVarNamed: name.
		var isSandstoneActiveRecord 
			ifTrue: 
				[ self 
					instVarNamed: name
					put: var asReferenceMarker ]
			ifFalse: [ var sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:06'!
sandstoneResolveReferences
	"Replaces the receiver markers with
	active records where it is needed"
	^ self sandstoneResolveReferencesVisits: (IdentityDictionary new: self sandstoneInitialHashSize)! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 16:25'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ it ].
	visitedParts at: self put: self.
	self class allInstVarNames do: 
		[ :name | 
		| var |
		var := self instVarNamed: name.
		(var isSandstoneMarker) 
			ifTrue: 
				[ self 
					instVarNamed: name
					put: var asOriginalObject ]
			ifFalse: [ var sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

Object subclass: #SDAbstractStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDAbstractStore commentStamp: 'rjl 8/10/2008 11:41' prior: 0!
I'm an abstract store to define what's necessary to plug in a new method of storing active records.  When records are stored, they are already sliced out of the graph and have markers for any other references placed in them.  The store can serialize however it sees fit, but when loading, before returning the version from the store, it should resolve the references.'!

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 16:48'!
abortChanges: anObject
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/11/2008 19:19'!
commit: aBlock
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'defaults' stamp: 'rjl 8/14/2008 15:37'!
defaultCacheSize
	^ 10000! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 13:39'!
ensureDown! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/10/2008 11:46'!
ensureForClass: aClass 
	"at startUp, the store is sent this message to tell it to make sure it's ready to run, a
	file store for instance may want to make sure it's directories exist"
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 20:41'!
forClass: aClass 
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 20:23'!
forClass: aClass at: anId ifAbsent: aHandler
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 20:24'!
forClass: aClass detect: aBlock ifFound: aHandler
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 20:24'!
forClass: aClass detect: aBlock ifNone: aHandler
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:00'!
forClass: aClass do: aBlock 
	! !

!SDAbstractStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 20:27'!
forClass: aClass findAll: aBlock
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:50'!
loadClass: aClass atId: anId 
	"Given a class and an Id, the store is expected to load a fresh copy of the object 
	from it's persistent medium'"
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/10/2008 11:49'!
recoverForClass: aClass
	"The store is expected to loop through all it's stored instances of a class and
	load them via cachedLoadFrom: on the class which will dispatch back to 
	loadObjectOfClass:atId on the store when a cached version of the object is not found.
	This happens once per class at system startup"
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/11/2008 19:13'!
removeObject: anObject 
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/11/2008 19:13'!
storeObject: anObject 
	self subclassResponsibility! !

!SDAbstractStore methodsFor: 'actions' stamp: 'rjl 8/15/2008 01:32'!
updateObject: anObject 
	self subclassResponsibility! !

SDAbstractStore subclass: #SDCachedStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDCachedStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:48'!
addCachedOfClass: aClass at: anId put: anObject ! !

!SDCachedStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:48'!
cachedLoadOfClass: aClass from: anId 
	self subclassResponsibility! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:03'!
familyForClass: aClass 
	self subclassResponsibility! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:02'!
forClass: aClass 
	^ (self familyForClass: aClass) values! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:03'!
forClass: aClass at: anId ifAbsent: aHandler 
	^ (self familyForClass: aClass) 
		at: anId
		ifAbsent: aHandler! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/27/2008 09:08'!
forClass: aClass detect: aBlock ifFound: aHandler 
	^ ((self forClass: aClass) 
		detect: aBlock
		ifNone: [ nil ]) ifNotNilDo: aHandler! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:03'!
forClass: aClass detect: aBlock ifNone: aHandler 
	^ (self forClass: aClass) 
		detect: aBlock
		ifNone: aHandler! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:03'!
forClass: aClass do: aBlock 
	(self forClass: aClass) do: aBlock! !

!SDCachedStore methodsFor: 'delegated queries' stamp: 'rjl 8/14/2008 21:03'!
forClass: aClass findAll: aBlock 
	^ (self forClass: aClass) select: aBlock! !

!SDCachedStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:48'!
removeCachedOfClass: aClass from: anId ! !

SDCachedStore subclass: #SDFileStore
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Store'!

!SDFileStore commentStamp: 'rjl 8/10/2008 11:42' prior: 0!
I'm a store for persisting active records directly to disk via a SmartReference stream with a few extentions to make it non interactive.'!

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 16:48'!
abortChanges: anObject 
	| diskVersion |
	anObject critical: 
		[ self 
			removeCachedOfClass: anObject class
			from: anObject id.
		diskVersion := self 
			cachedLoadOfClass: anObject class
			from: anObject id.
		diskVersion 
			ifNil: 
				[ self 
					addCachedOfClass: anObject class
					at: anObject id
					put: anObject ]
			ifNotNil: [ anObject becomeForward: diskVersion ] ]! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:26'!
addCachedOfClass: aClass at: anId put: anObject 
	(cache at: aClass) 
		at: anId
		put: anObject! !

!SDFileStore methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:50'!
cachedLoadOfClass: aClass from: anId 
	^ (cache at: aClass) 
		at: anId
		ifAbsent: 
			[ (
			[ self 
				loadClass: aClass
				atId: anId ] 
				on: SDLoadError
				do: [ nil ]) ifNotNilDo: 
				[ :it | 
				"seems I have to make sure to cache the object before I can resolve 
				it's references so any backreferences to it don't try and load from 
				disk again''"
				(cache at: aClass) 
					at: anId
					put: it.
				it sandstoneResolveReferences ] ]! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/11/2008 19:20'!
commit: aBlock
	self shouldNotImplement! !

!SDFileStore methodsFor: 'defaults' stamp: 'rjl 8/9/2008 23:33'!
defaultBaseDirectory
	"you can override this if you want to force the db somewhere else"
	^ FileDirectory default directoryNamed: 
		(FileDirectory baseNameFor: 
			(FileDirectory localNameFor: 
				SmalltalkImage current imageName)) , '.SandstoneDb'! !

!SDFileStore methodsFor: 'crash recovery' stamp: 'rjl 8/10/2008 01:27'!
deleteFailedCommitsForClass: aClass 
	"all remaining .new files are failed commits, kill them"
	
	[ (self dirForClass: aClass) fullNamesOfAllFilesInSubtree 
		select: [ :each | each endsWith: '.new' ]
		thenDo: [ :each | FileDirectory deleteFilePath: each ] ] 
		on: Error
		do: [ :err | Transcript show: err ]! !

!SDFileStore methodsFor: 'queries' stamp: 'rjl 9/18/2008 11:16'!
dirForClass: aClass 
	"compute the path of superclasses all the way up to ActiveRecord, storing 
	subclass records as a subdirectory of the superclasses directory 
	allows ActiveRecord to deal with inheritance"
	| parentClass lineage |
	aClass == SDActiveRecord ifTrue: 
		[ Error signal: 'ActiveRecord itself is abstract, you must only  
 store subclasses' ].
	lineage := OrderedCollection with: aClass.
	parentClass := aClass superclass.
	[ parentClass == SDActiveRecord ] whileFalse: 
		[ lineage addFirst: parentClass.
		parentClass := parentClass superclass ].
	^ lineage 
		inject: self defaultBaseDirectory
		into: [ :dir :each | dir directoryNamed: each name ]! !

!SDFileStore methodsFor: 'queries' stamp: 'rjl 8/10/2008 01:27'!
dirForClass: aClass atId: anId 
	"Grab the correct hashed subdirectory for this record"
	^ (self dirForClass: aClass) directoryNamed: (self dirNameFor: anId)! !

!SDFileStore methodsFor: 'queries' stamp: 'rjl 8/10/2008 00:17'!
dirNameFor: anId 
	"Answers a string with one decimal digit corresponding to anId.  There is a bug
	in this that does not ever hash to the directory 1, but because of existing datasets
	this must remain, do not want to rehash my databases and it is no big deal"
	self flag: #knownBug.
	^ (anId inject: 0 into: [ : sum : e | sum + e asInteger ]) asReducedSumOfDigits asString! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 9/14/2008 08:38'!
ensureDown
	self initializeCache ! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:27'!
ensureForClass: aClass 
	| dir |
	dir := (self dirForClass: aClass) assureExistence.
	0 
		to: 9
		do: [ :num | (dir directoryNamed: num asString) assureExistence ].
	cache 
		at: aClass
		ifAbsentPut: 
			[ SDConcurrentDictionary on: (Dictionary new: self defaultCacheSize) ]! !

!SDFileStore methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:44'!
familyForClass: aClass 
	"I'm returing raw cache dictionary here because this read only copy
	doesn't need concurrency protection, just a naked dictionary''"
	^ aClass allSubclasses 
		inject: (cache at: aClass) dictionary
		into: [ :sum :subclass | sum , (cache at: subclass) dictionary ]! !

!SDFileStore methodsFor: 'crash recovery' stamp: 'rjl 8/10/2008 01:27'!
finishPartialCommitsForClass: aClass 
	"find where .new exists but .obj doesn't, rename .obj.new to
	.obj to finish commit'"
	
	[ (self dirForClass: aClass) fullNamesOfAllFilesInSubtree 
		select: [ :each | each endsWith: '.obj.new' ]
		thenDo: 
			[ :each | 
			| objFile dir |
			objFile := FileDirectory localNameFor: (each 
					copyReplaceAll: '.new'
					with: '').
			dir := FileDirectory forFileName: each.
			(dir fileExists: objFile) ifFalse: 
				[ dir 
					rename: (FileDirectory localNameFor: each)
					toBe: objFile ] ] ] 
		on: Error
		do: 
			[ :err | 
			Transcript
				show: err;
				cr ]! !

!SDFileStore methodsFor: 'initialization' stamp: 'rjl 9/14/2008 08:37'!
initialize
	super initialize.
	self initializeCache! !

!SDFileStore methodsFor: 'initialization' stamp: 'rjl 9/14/2008 08:37'!
initializeCache
	cache := SDConcurrentDictionary on: (Dictionary new: self defaultCacheSize)! !

!SDFileStore methodsFor: 'crash recovery' stamp: 'rjl 9/14/2008 08:40'!
loadChangesForClass: aClass 
	| id obj |
	(self dirForClass: aClass) withSubdirectoriesDo: [ :dir | 
		[ dir entries do: 
			[ :each | 
			"there could be tens of thousands of entries, so using do with 
			a condition to avoid the copy a select would generate"
			each isDirectory ifFalse: 
				[ id := each name copyUpTo: $..
				obj := (cache at: aClass) at: id ifAbsent: [ nil ].
				obj 
					ifNil: [ self cachedLoadOfClass: aClass from:  id ]
					ifNotNil: [ obj abortChanges ] ] ] ]
			on: Error
			do: [ :err | Transcript 	show: err; 	cr ] ]! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:50'!
loadClass: aClass atId: anId 
	^ 
	[ SmartRefStream 
		readOnlyFileNamed: ((self 
			dirForClass: aClass
			atId: anId) fullNameFor: anId , '.obj')
		do: [ :file | file sandstoneNextAndClose ] ] 
		on: Error
		do: [ :err | SDLoadError signal: err messageText ]! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/10/2008 01:24'!
recoverForClass: aClass 
	self
		finishPartialCommitsForClass: aClass;
		deleteFailedCommitsForClass: aClass;
		loadChangesForClass: aClass! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 11/15/2008 16:54'!
removeCachedOfClass: aClass from: anId 
	"calling delete multiple times shouldn't cause an error"
	^ (cache at: aClass) removeKey: anId
		ifAbsent: [ nil ]! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:28'!
removeObject: anObject 
	| dir |
	self removeCachedOfClass: anObject class from: anObject id.
	dir := (self 	dirForClass: anObject class atId: anObject id).
	dir deleteFileNamed: anObject id , '.obj'.
	"kill any other versions or failed commits of this object"
	(dir fileNamesMatching: anObject id , '.*') do: [ :e | dir deleteFileNamed: e ]! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:18'!
storeObject: origObject 
	"The basic idea here is to make a save as atomic as possible and no data 
	is corrupted, no partial writes, thus renaming files as atomic."
	| currentVersion newVersion oldVersion dir anObject |
	(cache at: origObject class) at: origObject id put: origObject.
	anObject := origObject sandstoneDeepCopy sandstoneMarkReferences.
	dir := self dirForClass: anObject class atId: anObject id.
	currentVersion := dir fullNameFor: anObject id , '.obj'.
	newVersion := currentVersion , '.new'.
	oldVersion := currentVersion , '.old'.
	"just in case a previous commit failed and left junk around"
	dir deleteFileNamed: newVersion.
	"the flush ensures all data is actually written to disk before moving on"
	SmartRefStream 
		newFileNamed: newVersion
		do: [ :file |  file 	sandstoneNextPutObjOnly: anObject; flush ].
	"just in case any junk was lying around that failed to die on last commit"
	dir deleteFileNamed: oldVersion.
	"the pre-commit, on first save there won't be a current version, and fileExists is 
	too expensive to check when it'll always be there except on first save"
	[ dir sandstoneRename: currentVersion toBe: oldVersion ] ifError: [ "just ignore it" ].
	"now the actual commit"
	dir sandstoneRename: newVersion toBe: currentVersion.
	"clean up the junk (could fail if OS has lock on it for some reason)"
	dir deleteFileNamed: oldVersion! !

!SDFileStore methodsFor: 'actions' stamp: 'rjl 8/15/2008 01:32'!
updateObject: anObject
	self storeObject: anObject! !

SDCachedStore subclass: #SDMemoryStore
	instanceVariableNames: 'cache'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'SandstoneDb-Store'!

!SDMemoryStore commentStamp: 'rjl 8/10/2008 11:43' prior: 0!
I'm a store for persisting active records directly to a dictionary to show what a minimal implementation of a store must to do pass the unit tests.!

!SDMemoryStore class methodsFor: 'initialization' stamp: 'rjl 8/10/2008 11:16'!
initialize
	"self initialize"
	Cache := Dictionary new.
	! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 16:52'!
abortChanges: anObject 
	| diskVersion |
	anObject critical: 
		[ self 
			removeCachedOfClass: anObject class
			from: anObject id.
		diskVersion := self 
			cachedLoadOfClass: anObject class
			from: anObject id.
		diskVersion 
			ifNil: 
				[ self 
					addCachedOfClass: anObject class
					at: anObject id
					put: anObject ]
			ifNotNil: [ anObject becomeForward: diskVersion ] ]! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:45'!
addCachedOfClass: aClass at: anId put: anObject 
	(cache at: aClass) 
		at: anId
		put: anObject! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:50'!
cachedLoadOfClass: aClass from: anId 
	^ (cache at: aClass) 
		at: anId
		ifAbsent: 
			[ (
			[ self 
				loadClass: aClass
				atId: anId ] 
				on: SDLoadError
				do: [ nil ]) ifNotNilDo: 
				[ :it | 
				"seems I have to make sure to cache the object before I can resolve 
				it's references so any backreferences to it don't try and load from 
				disk again''"
				(cache at: aClass) 
					at: anId
					put: it.
				it sandstoneResolveReferences ] ]! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/11/2008 19:20'!
commit: aBlock
	self shouldNotImplement! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:37'!
ensureForClass: aClass 
	cache 
		at: aClass
		ifAbsentPut: [ Dictionary new: self defaultCacheSize ]! !

!SDMemoryStore methodsFor: 'queries' stamp: 'rjl 8/14/2008 21:02'!
familyForClass: aClass 
	"I'm returing raw cache dictionary here because this read only copy
	doesn't need concurrency protection, just a naked dictionary''"
	^ aClass allSubclasses 
		inject: (cache at: aClass) 
		into: [ :sum :subclass | sum , (cache at: subclass)  ]! !

!SDMemoryStore methodsFor: 'actions' stamp: 'test 9/18/2008 11:21'!
initialize
	super initialize.
	Cache := Dictionary new.
	cache := Dictionary new! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 20:50'!
loadClass: aClass atId: anId 
	^ (Cache at: anId) sandstoneResolveReferences! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:06'!
recoverForClass: aClass 
	Cache keysDo: [ :e |  self cachedLoadOfClass: aClass from:  e ]! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:48'!
removeCachedOfClass: aClass from: anId 
	^ (cache at: aClass) 
		removeKey: anId
		ifAbsent: [ SDError signal: 'Deleted or new objects cannot be aborted' ]! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:46'!
removeObject: anObject 
	self 
		removeCachedOfClass: anObject class
		from: anObject id.
	Cache removeKey: anObject id ifAbsent: []! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:39'!
storeObject: anObject 
	self 
		addCachedOfClass: anObject class
		at: anObject id
		put: anObject.
	Cache 
		at: anObject id
		put: anObject sandstoneDeepCopy sandstoneMarkReferences! !

!SDMemoryStore methodsFor: 'actions' stamp: 'rjl 8/15/2008 01:33'!
updateObject: anObject
	self storeObject: anObject! !

Object subclass: #SDActiveRecord
	instanceVariableNames: 'id createdOn updatedOn version isNew'
	classVariableNames: 'Store'
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

SDActiveRecord class
	instanceVariableNames: 'locks'!

!SDActiveRecord commentStamp: 'rjl 8/5/2008 09:35' prior: 0!
I'm the core of a simple object database based upon a mix of several patterns intended for use with *small* Seaside based web applications.  I am not meant to scale to millions of records, just tens of thousands, but for prototyping and small office applications where the number of records are in the thousands and the number of concurrent users can be handled by a single Squeak image.  To use me, simply subclass me and restart your image that's it.  

For more information see http://onsmalltalk.com/programming/smalltalk/sandstonedb-simple-activerecord-style-persistence-in-squeak/
!

SDActiveRecord class
	instanceVariableNames: 'locks'!

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/5/2008 11:14'!
atId: anId 
	"hitting this in a tight loop for a class with subclasses can be very expensive
	because allCaches has to concatenate all the subclasses caches into a new copy
	that contains all subclass records"
	^ self 
		atId: anId
		ifAbsent: [ nil ]! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:22'!
atId: anId ifAbsent: aHandler 
	"hitting this in a tight loop for a class with subclasses can be very expensive
	because allCaches has to concatenate all the subclasses caches into a new copy
	that contains all subclass records"
	^  Store forClass: self at: anId ifAbsent: aHandler! !

!SDActiveRecord class methodsFor: 'actions' stamp: 'rjl 8/11/2008 20:26'!
commit: aBlock 
	^ Store commit: aBlock! !

!SDActiveRecord class methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:08'!
coolDown
	locks := nil.
	self ensureReady! !

!SDActiveRecord class methodsFor: 'accessing defaults' stamp: 'rjl 8/9/2008 23:40'!
defaultStore
	^ SDFileStore new! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:23'!
do: aBlock
	"do on a copy in case the do modifies the collection I'm trying to iterate'"
	Store forClass: self do: aBlock! !

!SDActiveRecord class methodsFor: 'actions private' stamp: 'rjl 8/14/2008 15:10'!
ensureReady
	locks ifNil: [ locks := SDConcurrentDictionary 
		on: (WeakKeyDictionary new: 10000) ]! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 3/31/2008 14:19'!
find: aBlock 
	^ self 
		find: aBlock
		ifAbsent: [ nil ]! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:24'!
find: aBlock ifAbsent: aHandler 
	^ Store forClass: self detect: aBlock ifNone: aHandler! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:24'!
find: aBlock ifPresent: aHandler 
	^ Store forClass: self detect: aBlock ifFound: aHandler! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:41'!
findAll
	^ Store forClass: self! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 8/14/2008 20:27'!
findAll: aBlock 
	^ Store forClass: self findAll: aBlock! !

!SDActiveRecord class methodsFor: 'initialization' stamp: 'rjl 8/10/2008 00:37'!
initialize
	"SDCheckPointer now handles startUp:, this 
	cleans up any previously registered ActiveRecord
	startUp processes"
	"self initialize"
	Store := self defaultStore.
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
	self allSubclassesDo: 
		[ :e | 
		Smalltalk removeFromStartUpList: e.
		Smalltalk removeFromShutDownList: e ]! !

!SDActiveRecord class methodsFor: 'queries private' stamp: 'rjl 7/7/2008 23:13'!
lockFor: anInstance 
	^ locks 
		at: anInstance id
		ifAbsentPut: [ Monitor new ]! !

!SDActiveRecord class methodsFor: 'initialization' stamp: 'rjl 8/31/2008 20:59'!
setStore: aStore 
	Store ifNotNil: [ Store ensureDown ].
	Store := aStore! !

!SDActiveRecord class methodsFor: 'accessing' stamp: 'rjl 8/14/2008 15:31'!
store
	^ Store! !

!SDActiveRecord class methodsFor: 'actions' stamp: 'rjl 8/10/2008 01:23'!
warmUp
	| loadTime |
	loadTime := 
	[ Store ensureForClass: self.
	self ensureReady.
	Store recoverForClass: self ] timeToRun milliSeconds.
	Transcript
		show: self name , ' loaded in ' , loadTime asString;
		cr! !

!SDActiveRecord methodsFor: 'comparing' stamp: 'rjl 7/31/2008 16:49'!
= anObject 
	"asking the object isMemberOf ensures that if it's a proxy that message 
	will be forwarded to the real object.  Checking this condition in reverse
	anObject class, will fail because anObject class will be the ProxyClass"

	^ (anObject isMemberOf: self class) and: [ id = anObject id ]! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 8/14/2008 16:48'!
abortChanges
	"Rollback object to the last saved version"
	Store abortChanges: self.
! !

!SDActiveRecord methodsFor: 'converting' stamp: 'rjl 9/14/2008 08:44'!
asReferenceMarker
	isNew ifTrue: 
		[ "Programmers may reach this point several times until they get the intended use of
		this solution. This is expected **by design** to make atomic saves really small 
		and consistent. Commits of active records which have other active records as parts (at any deep)
		are restricted intentionally. They only are allowed when all its sub active records are previously commited.
		Only the programmer knows the proper logical commit order for his data!! This is not a relational database,
		if you absolutely need several objects to be atomically saved, then you should make them all part of a 
		single aggregate, all of your objects should not be active records, only your aggregate roots are active records...
			http://domaindrivendesign.org/discussion/messageboardarchive/Aggregates.html'"
		SDCommitError signal: 'An object is being saved while referencing an unsaved peer of type ' , self class name , '.  You must save that record first!!' ].
	^ SDRecordMarker new
		id: id ;
		className: self class name ;
		yourself! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 4/26/2008 22:26'!
createdOn
	^ createdOn! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 8/9/2008 22:33'!
critical: aBlock
	^ (self class lockFor: self) critical: aBlock! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 8/14/2008 15:19'!
delete
	"I'm using monitors for locking so this can be wrapped in larger critical
	in your application code if you want more scope on the critical'"
	self critical: 
		[ self onBeforeDelete.
		Store removeObject: self.
		self onAfterDelete.
		self initialize ]! !

!SDActiveRecord methodsFor: 'comparing' stamp: 'rjl 3/31/2008 14:08'!
hash
	^ id hash! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 1/16/2008 18:40'!
id
	^ id! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 12/5/2008 22:47'!
indexString
	"All instance variable's asStrings as a single delimeted string for easy searching"
	^ String streamContents: 
		[ :s | 
		self class allInstVarNames do: 
			[ :each | 
			(self instVarNamed: each) ifNotNilDo: 
				[ :value | 
				s
					nextPutAll: value asString;
					nextPutAll: '~~' ] ] ]! !

!SDActiveRecord methodsFor: 'initialize-release' stamp: 'rjl 1/16/2008 18:41'!
initialize
	super initialize.
	id := UUID new asString36.
	createdOn := updatedOn := TimeStamp now.
	version := 0.
	isNew := true! !

!SDActiveRecord methodsFor: 'testing' stamp: 'rjl 5/12/2008 20:43'!
isNew
	"Only answers true before an objects first save."
	^ isNew ifNil: [ isNew := true ]! !

!SDActiveRecord methodsFor: 'testing' stamp: 'rjl 5/12/2008 20:43'!
isSandstoneActiveRecord
	"Answers true if the receiver is a Sandstone Active Record."
	^ true! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:16'!
onAfterDelete
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:29'!
onAfterFirstSave
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:29'!
onAfterSave
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:29'!
onBeforeDelete
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 5/9/2008 09:56'!
onBeforeFirstSave
	"for overriding in subclasses to hook the objects lifecycle"
	createdOn := TimeStamp now! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:16'!
onBeforeSave
	"for overriding in subclasses to hook the objects lifecycle"
	updatedOn := TimeStamp now.
	version := version + 1.
	isNew := false! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 8/15/2008 01:34'!
save
	"I'm using monitors for locking so this can be wrapped in larger critical
	in your application code if you want more scope on the critical'"
	| isFirstSave |
	^ self critical: 
		[ self validate.
		(isFirstSave := isNew) ifTrue: [ self onBeforeFirstSave ].
		self onBeforeSave.
		isFirstSave 
			ifTrue: [Store storeObject: self] 
			ifFalse: [Store updateObject: self].
		isFirstSave ifTrue: [ self onAfterFirstSave ].
		self onAfterSave.
		self ]! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 8/9/2008 22:32'!
save: aBlock 
	^ self critical: 
		[ aBlock value.
		self save ]! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 3/31/2008 14:17'!
updatedOn
	^ updatedOn! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 3/31/2008 14:17'!
validate
	"for subclasses to override and throw exceptions to prevent saves"! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 3/31/2008 14:17'!
version
	^ version! !

SDActiveRecord subclass: #SDPersonMock
	instanceVariableNames: 'name dateOfBirth description father mother children buddy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

SDPersonMock subclass: #SDManMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

!SDPersonMock class methodsFor: 'as yet unclassified' stamp: 'rjl 4/1/2008 11:53'!
testPerson
	^ (self new)
		name: 'mzqfmmv zptnhli';
		dateOfBirth: Date today - 12000 atRandom days;
		description: 'Rxvalpv tdpqkvv ikjcscw bigjmeb vukntxj qxshdtt wkczzio bqpqacu whluhqv.  Lqlwajh!!  Qknwpfd peeskqc oarthtv pfblwjj yndlxks.  .  Ucnlocq iuiiluk txkkzmh dshkhmq uokcwqy oiktkxl awxmpep rkkcmis xcgyoeg jodtjaf ntwijzp?  Bqpjsiq qthzwtx xcnqbag ausurqp xatoqar jytguon?  Bpigdij jgijxep bjgttpr kklsfaw rdoikwz!!  Hzdbjxc?  Ehwflyy qfcqntk mlhcjql ecbtrtk egxldpk rypalvw ndngbdl jhhdxts zrfjtaz gccrnni dwuqxwm nmifzcq sxkgkxh.  Kwtzsjv ghvjqqm lfgibdt rufcowp kavabmi bpveqsr shjzsft xqaxivy fjqydns ryyggif.

Jshooyy jsyojlv miusnaj onpdiss hypkzzd qaunpqd rrvgnws ekiswyv?  Glhxkkk?  Pzyjuot raaefbv cnxmbsd?  Jabaniw uirjkcm jocxnhd!!  Erwblox qikxfez.

Ezswaga cnrzhqi jrdikos kkcncxd eoewflm ylzilve viumpqm uiyqhvv azrezhc jjeesfd rfdgsgg wfmxfye iisisju vhjourb.

Yicqnqd zhaioos npnjjsc hxfwlfr ozynyjs!!  Qavvubu uodeedp?  Fjdgbxu ryswazg ifumqpv jtlifnd?  Blciucl kypalot?  Dstnwqj kwzpxrk bgewcyp triddbr acvrkey pwgcleb sqtxajv svzpnwk unnlmtg oqnbpsq svtnxdo!!

Ywodawk uikhwek kyqivqj iojkwiw.  Bjcsnpu jtfpmqd!!  Crwlngk qeeeuci nnakbai hncfdkk kbhehju ttdsdcf zqulfpj pmvtmfa xrusxuy wbamfee opzjdia hcrfdnz tiasrqz wkwidbg?  Tzlwcst twaeuwm tfhreal igamlby saekozk tjnxohl ogcdhva fckbaii utqvhjg?  Nrynpjl dniycpm kkvytuu bnuxrev zrvbcph.  Awfbhgg xtyffnz lwjkhdo evmvogt vqfqppp chdtxcr ktiwujg vcgqoya thgkhac ncagoxy unuukan gntyowz obmiwmf!!  Okwjujz tfghbxi jupstni xbzpgau zlxeblm!!  Llxuwqc gupeurb ltwyzzj xxanyln qgrtigr?

Vudeenm hnfwxay rtaacau ymmyxbi lpcbamg ifopjuw guhctxx radytrh yubjcjc lnjucta qinzmlf.  Cnunlvp gdhcgrq oxeojsd?  Bbkjtne kzlvdso xtmgqhj pfyroxl brmqhkt gvqnftz aupxtsg.

Krzxaye!!  Clhbjoq ubxtlsc jzhggvl updbzxe.

Vhtetst ruwpukn jdttpba?  Ctwactb ljoeiqa pubapwc cioporv?

Talkecn dbddhuw rxfybrf iwdxfdo spdbdyk vhxbgrm elqngon dytngbm knqxaqv zrltvgh snjkzig rzypaly ekabqcg.  Xxxmegt otxzkhh vxpyjkn pnhgpfx qsnrhjo ziftvuu ivvfacz nhdajef ezksurr gvfepxx.  Lqdldbo wegkzlk qxgqpux hfbtydd hbqfhea gxuksjm hvunuwa?  Lxqkddp bccukhy odljtnp nouapus dcqpkqz lgpxpcs fmaehsc cgybese gujcbqz icjzamy tvmvwlf dvtkpng!!  !!  Okqxkhh dfuulea?  Ratgmpz?  Pfmgfbk qhggllc.  Balobww?

Wqoyfli xlxenvi ngtdshb bhpmyhd.  Kxsidry wijdkem oyuutvw msunbhq vaektbt yfapmwl yjrwmxi xgzfpbk hxcmydy jgaybjh magjtcf.  Koxatqi ivvultq yptadcp ygqutkn dizybis nvsvfhx tdhcqfy ihvqsvs paakztf uzokxhk xlcfhbr wejdutf wywzrqs tnlswyo?  Glawqav nvndvdf cbqzhce iuygwer twyxquv pjklwnv tbnazjw vuvxvgi?

Rpyaiqq rnvfyzk fgbsbjc zhftunh uvmxaov vgvwzwq fpuurxc!!  Zemojud eadzsas wzfdcuv vxvulbc ahtiijq yclzbvf rspxhrc lymmwja!!  Mfmgrrb!!  Cyfuuvp iabqntx volbiij ebjihqw ypxvukv wnghvwo fhqwyuh tlmeyrl oxcmotx uemizkc xvbgzqh xsdqtcj xfbzrgg?  Jmtauxu!!  Kbigzux slwjszd manystg usxbiya kfgdygh wrclmih chqtyew orkrazt pekdcrh oexrivu bnbrerh?

Xbkcyvl xivutzr iitbwnm eouuiux iwaansa oxzygwa sosqxvi jkinurb bedwzss?  Uspwzru.  Eogmjki raowczb!!  ?  Lfzhatu ldnvhfn rzfqfcl yzhbxpo evahsye eibcwlx ygknqms terepdi acvezip lyqydat bksesji.  Sncraae sropzde xdhuuuf?  ?

Vtcevnw dqwwzqe kqmakan wboltvp axuhsio eddpqvk hmaqsst kbqyeqg qjnlkph zjrrcdr glyqfak!!  Ciofqeq qzfzdxn aumczcs yxzdrqu hxnlhmo ihnowav nqggjoi dfdxzqr.

Wiedtvt jpikavx hkxvzqi eyobbcb hxhktut qpgasux bnwnzhp xaceikr comlnmg jkdzrhn hctccgm zcjgqbc llklclt!!

Bgyypck fvgaauj bzetcjo rqixcnx ggwuzax cnknyiv vbtnkxj zkmenql ynxyqpp vqnvihq qydzixk jvsbxhw qnbphdl uddayfe!!  Glalnun gbtcspy kxnzokz ecdpgpr kcmvcdf ngczhkp oovhcik yvlzbgl?';
		yourself! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 3/10/2008 21:44'!
buddy
	^ buddy! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 3/10/2008 21:44'!
buddy: anObject
	buddy := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/11/2007 10:33'!
children
	^ children! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/11/2007 10:33'!
children: anObject
	children := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
dateOfBirth
	^ dateOfBirth! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
dateOfBirth: anObject
	dateOfBirth := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:08'!
description
	^ description! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
description: anObject
	description := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
father
	^ father! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
father: anObject
	father := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
mother
	^ mother! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
mother: anObject
	mother := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
name
	^ name! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
name: anObject
	name := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 4/22/2008 10:45'!
refreshed
	^ self class atId: id! !

SDPersonMock subclass: #SDWomanMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

SDWomanMock subclass: #SDChildMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

SDChildMock subclass: #SDGrandChildMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

Object subclass: #SDCheckPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDCheckPointer commentStamp: 'rjl 8/5/2008 09:17' prior: 0!
I run as a background process to ensure the database is loaded and periodically save the image when enough active records are found to be newer than the image.  This is essentially just like flushing the contents of a transaction log to the main database file.!

!SDCheckPointer class methodsFor: 'initialization' stamp: 'rjl 8/5/2008 19:55'!
initialize
	"SDCheckPointer will act as the single agent to ensure all active record 
	subclasses are correctly initialized on start up."
	"self initialize"
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self
! !

!SDCheckPointer class methodsFor: 'system startup' stamp: 'rjl 9/14/2008 08:47'!
shutDown: isDown 
	isDown ifTrue: 
		[ SDActiveRecord store ensureDown.
		SDActiveRecord allSubclassesDo: [ :each | each coolDown ] ]! !

!SDCheckPointer class methodsFor: 'system startup' stamp: 'rjl 11/19/2008 21:46'!
startUp: isStarting 
	"Had problems reusing images from templated sites or existing sites
	and accidently mixing old data or another db into this images data.
	I want to ensure that any time an image starts up fresh from disk it always
	reloads all the data; setting a fresh store on startup will ensure this happens."
	SDActiveRecord store isNil or: 
		[ isStarting ifTrue: [ SDActiveRecord setStore: SDActiveRecord defaultStore ] ].

	"Load records on a priority just higher than Seaside so db is loaded before
	requests start coming in, don't want users seeing missing data."
	
	[ isStarting ifTrue: 
		[ SDActiveRecord allSubclassesDo: [ :each | SDActiveRecord store ensureForClass: each ].
		SDActiveRecord allSubclassesDo: [ :each | each warmUp ] ] ] forkAt: Processor userBackgroundPriority + 1
		named: 'loading sandstone'! !

Object subclass: #SDConcurrentDictionary
	instanceVariableNames: 'lock dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDConcurrentDictionary commentStamp: 'rjl 5/9/2008 20:58' prior: 0!
A SDConcurrentDictionary is just a dictionary wrapper so I can wrap a critical around mutating methods I need in ActiveRecord!

!SDConcurrentDictionary class methodsFor: 'instance creation' stamp: 'rjl 5/9/2008 20:11'!
on: aDictionary 
	^ self new
		dictionary: aDictionary;
		yourself! !

!SDConcurrentDictionary methodsFor: 'copying' stamp: 'rjl 5/9/2008 21:40'!
, aCollection 
	^ lock critical: [ self class on: dictionary , aCollection ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:30'!
at: aKey
	^ dictionary at: aKey! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 21:11'!
at: aKey ifAbsent: aBlock 
	^ lock critical: 
		[ dictionary 
			at: aKey
			ifAbsent: aBlock ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:53'!
at: aKey ifAbsentPut: aBlock 
	^ lock critical: 
		[ dictionary 
			at: aKey
			ifAbsentPut: aBlock ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:53'!
at: aKey put: aValue 
	^ lock critical: 
		[ dictionary 
			at: aKey
			put: aValue ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 8/5/2008 10:55'!
dictionary
	^ dictionary! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:11'!
dictionary: anObject
	dictionary := anObject! !

!SDConcurrentDictionary methodsFor: 'testing' stamp: 'rjl 5/9/2008 20:29'!
includesKey: aKey
	^ dictionary includesKey: aKey! !

!SDConcurrentDictionary methodsFor: 'initialization' stamp: 'rjl 5/9/2008 21:35'!
initialize
	super initialize.
	"I'm using a Monitor rather than a Semaphor here because I need to support 
	reentrant operations by the same process, a Semaphor is too low level"
	lock := Monitor new! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 11/30/2008 12:59'!
keys
	^ dictionary keys! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:38'!
keysAndValuesDo: aBlock
	^ dictionary keysAndValuesDo: aBlock! !

!SDConcurrentDictionary methodsFor: 'removing' stamp: 'rjl 11/30/2008 13:00'!
removeAll
	^ lock
		critical: [self keys copy
				do: [:e | self removeKey: e]]! !

!SDConcurrentDictionary methodsFor: 'removing' stamp: 'rjl 11/30/2008 13:00'!
removeKey: aKey
	^ lock critical: 
		[ dictionary 
			removeKey: aKey ]! !

!SDConcurrentDictionary methodsFor: 'removing' stamp: 'rjl 5/9/2008 20:51'!
removeKey: aKey ifAbsent: aBlock 
	^ lock critical: 
		[ dictionary 
			removeKey: aKey
			ifAbsent: aBlock ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:39'!
values
	^ dictionary values! !

Object subclass: #SDRecordMarker
	instanceVariableNames: 'id className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDRecordMarker commentStamp: 'rjl 4/10/2008 21:32' prior: 0!
I exist to mark a reference to another object in the serialized file, I'm replaced by a real object when I'm deserialized.  I'm basically a manually invoked proxy being used because getting a real proxy that inherits from ProtoObject to serialize seemed hurculean.!

!SDRecordMarker methodsFor: 'converting' stamp: 'rjl 8/14/2008 16:23'!
asOriginalObject
	"this needs to call cachedLoadFrom not findById in order to allow cycles in 
	the serialized graph this allows an object that references an unloaded object 
	during the loadAll to force it's load instead of failing"
	| origClass |
	origClass := Smalltalk at: className.
	"I'm checking inheritsFrom: here so that any classes that used to be 
	activeRecords but aren't anymore that had serialized instances are 
	caught and return nil when resolved rather than blow up.  This happens
	often during development when you're changing your model a lot"
	^ (origClass inheritsFrom: SDActiveRecord) 
		ifTrue: [ SDActiveRecord store cachedLoadOfClass: (Smalltalk at: className)  from: id ]
		ifFalse: [ nil ]! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
className
	^ className! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
className: anObject
	className := anObject! !

!SDRecordMarker methodsFor: 'testing' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
id
	^ id! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
id: anObject
	id := anObject! !

!SDRecordMarker methodsFor: 'testing' stamp: 'rjl 7/8/2008 15:41'!
isSandstoneMarker
	^ true! !

!UndefinedObject methodsFor: '*sandstonedb' stamp: 'rjl 5/12/2008 22:37'!
sandstoneDeepCopy
	^ self! !

!UndefinedObject methodsFor: '*sandstonedb' stamp: 'rjl 5/12/2008 22:37'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!UndefinedObject methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:53'!
sandstoneMarkReferencesVisits: visitedParts
	^ self! !

!UndefinedObject methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:53'!
sandstoneResolveReferencesVisits: visitedParts 
	^ self! !

!Dictionary methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 20:34'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	newObject := self copy.
	newObject do: 
		[ :each | 
		each isSandstoneActiveRecord ifFalse: 
			[ self 
				at: (self keyAtValue: each)
				put: (each sandstoneDeepCopyVisits: visitedParts) ] ].
	^ newObject! !

!Dictionary methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 20:35'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ self ].
	visitedParts at: self put: self.
	self do: 
		[ :each | 
		each isSandstoneActiveRecord 
			ifTrue: [ self at: (self keyAtValue: each) put: each asReferenceMarker  ]
			ifFalse: [ each sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Dictionary methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 20:35'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	visitedParts at: self ifPresent: [ :it | ^ self ].
	visitedParts at: self put: self.
	"It is crucial to modify the introspectee by iterating a copy of it"
	self copy do: 
		[ :each | 
		each isSandstoneMarker 
			ifTrue: [ self at: (self keyAtValue: each) put: each asOriginalObject ]
			ifFalse: [ each sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

!LookupKey methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ true! !

!Number methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:46'!
sandstoneDeepCopy
	^ self! !

!Number methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:46'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Number methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:44'!
sandstoneMarkReferencesVisits: visitedParts
	^ self! !

!Number methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:44'!
sandstoneResolveReferencesVisits: visitedParts 
	^ self! !

!Bag methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:40'!
sandstoneDeepCopyVisits: visitedParts
       "sandstoneDeepCopy works just like deepCopy until it hits another active record
       at which point the copying stops, and the actual references is returned."
       | newObject |
       visitedParts at: self ifPresent: [ :it | ^ it ].
       newObject := self copy.
       newObject valuesAndCounts sandstoneDeepCopyVisits: visitedParts.
       ^ newObject! !

!Bag methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:41'!
sandstoneMarkReferencesVisits: visitedParts
       "Make components of the introspectee which are
       Sandstone active records to become references.
       Do this deeply (sub components)."
       self class isMeta ifTrue: [ ^ self ].
       self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
       visitedParts at: self ifPresent: [:it | ^ self ].
       visitedParts at: self put: self.
       self valuesAndCounts sandstoneMarkReferencesVisits: visitedParts.
       ^ self! !

!Bag methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:41'!
sandstoneResolveReferencesVisits: visitedParts
       "Make components of the introspectee which are
       Sandstone references to active record to become active records.
       Do this deeply (sub components)."
       self class isMeta ifTrue: [ ^ self ].
       visitedParts at: self ifPresent: [ :it | ^ self ].
       visitedParts at: self put: self.
       self copy valuesAndCounts sandstoneResolveReferencesVisits: visitedParts.
       ^ self! !

!Integer methodsFor: '*sandstonedb' stamp: 'rjl 4/10/2008 10:08'!
asReducedSumOfDigits
	"Answers the sum of the digits present in the 
	decimal representation of the receiver 
	but also repeating the procedure if the 
	answers is greater than 9."
	^ 10 <= self 
		ifFalse: [ self ]
		ifTrue: 
			[ self = 10 
				ifTrue: [ 0 ]
				ifFalse: 
					[ (self asString 
						inject: 0
						into: [ :sum :e | sum + e digitValue ]) asReducedSumOfDigits ] ]! !

!Set methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 19:55'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	visitedParts at: self ifPresent: [ :it | ^ self ].
	visitedParts at: self put: self.
	"It is crucial to modify the introspectee by iterating a copy of it"
	self copy doWithIndex: 
		[ :each :index | 
		each isSandstoneMarker 
			ifTrue: [ self remove: each; add: each asOriginalObject ]
			ifFalse: [ each sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

Error subclass: #SDError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDError commentStamp: 'rjl 4/10/2008 21:36' prior: 0!
I'm just an abstract error!

SDError subclass: #SDCommitError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDCommitError commentStamp: 'rjl 4/10/2008 21:33' prior: 0!
Clearly, I'm thrown on a commit failure, duh!!'!

SDError subclass: #SDLoadError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Core'!

!SDLoadError commentStamp: 'rjl 4/10/2008 20:24' prior: 0!
I'm thrown when an object fails to load from disk, either because the file was corrupt or because it was deleted.!

!Magnitude methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:45'!
deservesSandstoneReferenceMark
	^ false! !

!Collection methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:26'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	newObject := self copy.
	newObject do: 
		[ :each | 
		each isSandstoneActiveRecord ifFalse: 
			[ newObject remove: each.
			newObject add: (each sandstoneDeepCopyVisits: visitedParts) ] ].
	^ newObject! !

!Collection methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:33'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ self ].
	visitedParts at: self put: self.
	self copy do: [ :each  | 
		each isSandstoneActiveRecord 
			ifTrue: [ self remove: each; add: each asReferenceMarker ]
			ifFalse: [ each sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Collection methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 18:59'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	visitedParts at: self ifPresent: [ :it | ^ self ].
	visitedParts at: self put: self.
	"It is crucial to modify the introspectee by iterating a copy of it"
	self copy doWithIndex: 
		[ :each :index | 
		each isSandstoneMarker 
			ifTrue: [ self at: index put: each asOriginalObject ]
			ifFalse: [ each sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

!Array methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ {  Array. DependentsArray. WeakArray  } includes: self class! !

!SequenceableCollection methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:27'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	newObject := self copy.
	"optimized implementation taking advantaged of ordering"
	newObject doWithIndex: 
		[ :each :index | 
		each isSandstoneActiveRecord ifFalse: 
			[ newObject at: index put: (each sandstoneDeepCopyVisits: visitedParts) ] ].
	^ newObject! !

!SequenceableCollection methodsFor: '*sandstonedb' stamp: 'rjl 12/13/2008 10:31'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ self ].
	visitedParts at: self put: self.
	self doWithIndex: 
		[ :each :index | 
		each isSandstoneActiveRecord 
			ifTrue: [ self at: index put: each asReferenceMarker ]
			ifFalse: [ each sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!InstructionStream methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!Boolean methodsFor: '*sandstonedb' stamp: 'rjl 5/12/2008 22:32'!
sandstoneDeepCopy
	^ self! !

!Boolean methodsFor: '*sandstonedb' stamp: 'rjl 5/12/2008 22:33'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Boolean methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:55'!
sandstoneMarkReferencesVisits: visitedParts
	^ self! !

!Boolean methodsFor: '*sandstonedb' stamp: 'rjl 8/3/2008 00:55'!
sandstoneResolveReferencesVisits: visitedParts 
	^ self! !

!SmartRefStream methodsFor: '*sandstonedb' stamp: 'rjl 8/12/2008 08:11'!
sandstoneNextAndClose
	"Speedy way to grab one object. Only use when we are inside an object
	binary file.I created my own version of nextAndClose to get rid of the 
	interactive stuff the real one tries to do.  If I fail, then I fail, so be it"
	| obj |
	byteStream peek = ReferenceStream versionCode ifFalse: [ SDLoadError signal: 'old object file' ].
	obj := self next.
	self close.
	^ obj! !

!SmartRefStream methodsFor: '*sandstonedb' stamp: 'rjl 3/31/2008 21:34'!
sandstoneNextPutObjOnly: anObject 
	"Really write three objects: (version, class structure, object).  But only when called from the outside.  Not in fileOut format.  No class definitions will be written for instance-specific classes.  Error if find one.  (Use nextPut: instead)"
	| info |
	topCall 
		ifNil: 
			[ topCall := anObject.
			super nextPut: ReferenceStream versionCode.
			info := self instVarInfo: anObject.
			self uniClasesDo: [ :cls | cls error: 'Class defn not written out.  Proceed?' ].
			objCount := 0.
			super nextPut: info.
			super nextPut: anObject.	"<- the real writing"
			"Class inst vars not written here!!"
			topCall := nil
			"references is an IDict of every object that got written
			(in case you want to take statistics)"
			"Transcript cr; show: structures keys printString."	"debug"	"reset it" ]
		ifNotNil: [ super nextPut: anObject ]! !

!Morph methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !
SDMemoryStore initialize!
SDActiveRecord initialize!
SDCheckPointer initialize!
